<?php
namespace themeDevSocial\Apps\Counters;

if( ! defined( 'ABSPATH' )) die( 'Forbidden' );

use \themeDevSocial\Apps\Settings as Settings;

use \themeDevSocialNext\Providers\Abst\Util as Util;
use \themeDevSocialNext\Providers\Abst\Curl as Curl;

class Pinterest extends Settings{
	
	 /**
     * Custom post type
     * Method Description: Set custom post type
     * @since 1.0.0
     * @access public
	 */
	private $api_data = ''; 
	
	private $api_key = ''; 
	
	private $api_secret = ''; 
	
	private $access_token = ''; 
	
	private $user_id = 'themedev'; 
	
	protected $apiBaseUrl = 'https://api.pinterest.com/v1/';

    protected $profileUrlTemplate = 'https://www.pinterest.com/%s';
	
    private $callback = '';

	private $token = '';
	
	private $token_data = '';
    
    private $curl;
	/**
     * Method: __construct
     * Method Description: load services
     * @since 1.0.0
     * @access private
	 */
	public function __construct($load = true){
		if($load){
			$this->api_data = parent::__get_api_data_counter('pinterest');
			$this->api_key = isset($this->api_data['id']) ? $this->api_data['id'] : '';
            $this->api_secret = isset($this->api_data['secret']) ? $this->api_data['secret'] : '';
            $this->user_id = isset($this->api_data['user_id']) ? $this->api_data['user_id'] : $this->user_id;

			$this->token_data = isset($this->api_data['token']) ? $this->api_data['token'] : $this->token;

			$this->callback = get_site_url().'/wp-admin/admin.php?page=next-social-counter&tab=providers&type=pinterest';
            
            $this->curl = new Curl();
        }
	}
	
    /**
     * Method: get_access_token
     * Method Description: Get Access Token
     * @since 1.0.0
     * @access public
	 */
    
     public function __get_accesstoken(){
		if(strlen( trim($this->token_data) ) > 5){
			$this->token = trim($this->token_data);
			return $this->token;
		}
        $tokenData   = get_transient( '_next_social_access_token' );
        $dataToken = isset($tokenData['pinterest_token']) ? $tokenData['pinterest_token'] : '';

		$get_transient_time   = get_transient( 'timeout__next_social_access_token' );		
        if( $get_transient_time < time() || empty(trim($dataToken))){
            $access_tok = parent::_get_social_services('social_token');
            if(isset($access_tok['data'])){
                set_transient( '_next_social_access_token', $access_tok['data'] , parent::$cache*60*60 );
            }
        }
        $tokenData   = get_transient( '_next_social_access_token' );
        $this->token = isset($tokenData['pinterest_token']) ? $tokenData['pinterest_token'] : '';
        return  $this->token;
     }

     /**
     * Method: __get_follower_data
     * Method Description: Get Followers Info
     * @since 1.0.0
     * @access public
	 */
    
    
	public function __get_follower_data(){
		if(strlen( trim($this->token_data) ) < 5){
			return $this->__like_counter();
		}
		
		if( strlen($this->token) > 5){	
			$header = [
				'Authorization' => sprintf('Bearer %s', $this->token),
				'Content-Type' => 'application/x-www-form-urlencoded;charset=UTF-8',
				'Accept' => 'application/json'
			];
			
			$body = [
			];
			try {
                $url = $this->apiBaseUrl.'me/following/users?access_token='.$this->token;
				$reoponse = $this->curl->request( $url , 'GET', $body, $header);
				$reoponse = @json_decode($reoponse, true);
				
				if( isset($reoponse['likes']) && strlen($reoponse['likes']) > 0 ){
					
					return isset($reoponse['likes']) ? (int) $reoponse['likes'] : 0;
					
				}
			}
			catch (Exception $e) {
				return $this->__like_counter();
			}		
		}
		return $this->__like_counter();
	}

	private function __like_counter(){
		try {
			$counter = '';
			$url = 'https://www.pinterest.com/'.$this->user_id;
			$get_request = wp_remote_get($url, array( 'timeout' => 20 ) );
			$the_request = wp_remote_retrieve_body( $get_request );

			$prev = libxml_use_internal_errors( true );
            $doc    = new \DOMDocument();
            @$doc->loadHTML($the_request);
            libxml_use_internal_errors( $prev );
            
            $metas 	= $doc->getElementsByTagName('meta');
            for ($i = 0; $i < $metas->length; $i++){
                $meta = $metas->item($i);
                if($meta->getAttribute('name') == 'pinterestapp:followers'){
                    $counter = $meta->getAttribute('content');
                    break;
                }
            }
			return (int) $counter;
		}
		catch (Exception $e) {
			return 0;
		}
	}
}