<?php
namespace themeDevSocial\Apps\Providers;

if( ! defined( 'ABSPATH' )) die( 'Forbidden' );

use \themeDevSocial\Apps\Settings as Settings;

class Facebook extends Settings{
	
	 /**
     * Custom post type
     * Method Description: Set custom post type
     * @since 1.0.0
     * @access public
	 */
	private $api_data = ''; 
	
	private $api_key = ''; 
	
	private $api_secret = ''; 
	
	private $access_token = ''; 
	
	private $user_id = 'themedev2019'; 
	
	protected $apiBaseUrl = 'https://graph.facebook.com/v3.0/';

    protected $authorizeUrl = 'https://www.facebook.com/dialog/oauth';

    protected $accessTokenUrl = 'https://graph.facebook.com/v3.0/oauth/access_token';

    protected $apiDocumentation = 'https://developers.facebook.com/docs/facebook-login/overview';

    protected $profileUrlTemplate = 'https://www.facebook.com/%s';
	
	public $scope = ['id', 'message', 'form', 'story_tags', 'message_tags', 'source', 'picture', 'full_picture', 'link', 'name', 'caption', 'description', 'type', 'status_type', 'icon', 'created_time', 'updated_time', 'from{name,id,link,username,picture}', 'object_id', 'permalink_url', 'likes.limit(0).summary(true)', 'shares', 'comments.limit(0).summary(true)', 'reactions.limit(0).summary(true)', 'with_tags', 'is_published'];
	
	private $callback = '';
	
	/**
     * Method: __construct
     * Method Description: load services
     * @since 1.0.0
     * @access private
	 */
	public function __construct($load = true){
		if($load){
			$this->api_data = parent::__get_api_data('facebook');
			$this->api_key = isset($this->api_data['id']) ? $this->api_data['id'] : '';
			$this->api_secret = isset($this->api_data['secret']) ? $this->api_data['secret'] : '';
			$this->callback = get_site_url().'/wp-json/next-social-login/provider/facebook';
		}
	}
	/**
     * Method: api_authorise
     * Method Description: Api Authentication
     * @since 1.0.0
     * @access private
	 */
	public function api_authorise(){
		$config = [
			'enabled' => true,
			'callback' => $this->callback,
			'keys' => [
						'id' => $this->api_key,
						'secret' => $this->api_secret 
					]
		];
		
		$adapter = new \themeDevSocialNext\Providers\Facebook($config);
		return $adapter;
	}
	
}