<?php
namespace themeDevSocial\Apps\Providers;

if( ! defined( 'ABSPATH' )) die( 'Forbidden' );

use \themeDevSocial\Apps\Settings as Settings;

class Linkedin extends Settings{
	
	 /**
     * Custom post type
     * Method Description: Set custom post type
     * @since 1.0.0
     * @access public
	 */
	private $api_data = ''; 
	
	private $api_key = ''; 
	
	private $api_secret = ''; 
	
	private $access_token = ''; 
	
	private $user_id = 'themedev2019'; 
	
	protected $apiBaseUrl = 'https://api.linkedin.com/v1/';

    protected $authorizeUrl = 'https://www.linkedin.com/oauth/v2/authorization';

    protected $accessTokenUrl = 'https://www.linkedin.com/oauth/v2/accessToken';

    protected $apiDocumentation = 'https://developer.linkedin.com/docs/oauth2';

    protected $profileUrlTemplate = 'https://www.linkedin.com/in/';
	
	private $scope = [];
	
	private $callback = '';
	/**
     * Method: __construct
     * Method Description: load services
     * @since 1.0.0
     * @access private
	 */
	public function __construct($load = true){
		if($load){
			$this->api_data = parent::__get_api_data('linkedin');
			$this->api_key = isset($this->api_data['id']) ? $this->api_data['id'] : '';
			$this->api_secret = isset($this->api_data['secret']) ? $this->api_data['secret'] : '';
			$this->callback = get_site_url().'/wp-json/next-social-login/provider/linkedin';
			
		}
	}
	/**
     * Method: api_authorise
     * Method Description: Api Authentication
     * @since 1.0.0
     * @access private
	 */
	public function api_authorise(){
		$config = [
			'enabled' => true,
			'callback' => $this->callback,
			'keys' => [
						'id' => $this->api_key,
						'secret' => $this->api_secret 
					]
		];
		
		//$adapter = new \Hybridauth\Provider\LinkedIn($config);
		$adapter = new \themeDevSocialNext\Providers\Linkedin($config);
		return $adapter;
	}
	
}