<?php
namespace themeDevSocial\Apps\Providers;

if( ! defined( 'ABSPATH' )) die( 'Forbidden' );

use \themeDevSocial\Apps\Settings as Settings;

class Twitter extends Settings{
	
	 /**
     * 
     * Method Description: 
     * @since 1.0.0
     * @access public
	 */
	private $api_data = ''; 
	
	private $api_key = ''; 
	
	private $api_secret = ''; 
	
	private $access_token = ''; 
	
	private $user_id = 'themedev2019'; 
	
	protected $apiBaseUrl = 'https://api.twitter.com/1.1/';

    protected $authorizeUrl = 'https://api.twitter.com/oauth/authorize';

    protected $accessTokenUrl = 'https://api.twitter.com/oauth/access_token';

    protected $apiDocumentation = 'https://dev.twitter.com/web/sign-in/implementing';

	protected $profileUrlTemplate = 'https://www.twitter.com/%s';
	
	private $scope = [];
	
	private $callback = '';
	/**
     * Method: __construct
     * Method Description: load services
     * @since 1.0.0
     * @access private
	 */
	public function __construct($load = true){
		if($load){
			$this->api_data = parent::__get_api_data('twitter');
			$this->api_key = isset($this->api_data['id']) ? $this->api_data['id'] : '';
			$this->api_secret = isset($this->api_data['secret']) ? $this->api_data['secret'] : '';
			$this->callback = get_site_url().'/wp-json/next-social-login/provider/twitter';
		}
	}
	/**
     * Method: api_authorise
     * Method Description: Api Authentication
     * @since 1.0.0
     * @access private
	 */
	public function api_authorise(){
		$config = [
			'enabled' => true,
			'callback' => $this->callback,
			'keys' => [
						'key' => $this->provider->api_key,
						'secret' => $this->provider->api_secret 
					]
		];
		
		$adapter = new \themeDevSocialNext\Providers\Twitter($config);
		return $adapter;
	}
	
}